export type MetadataType = {
  [key: string]: string;
}

export type FieldType = {
  type: FieldTypes;
  value: string;
  isConstant: boolean;
  limit: number;
  minimum: number;
};

export type TypeType = Record<string, FieldType>;

export type Template = {
  type: string;
  publishable: boolean;
}

export type Schema = {
  id: string;
  name: string;
  templates: Record<string, Template>;
  types: Record<string, TypeType>;
}

export enum FieldTypes {
  number = 'number',
  text = 'text',
  'long text' = 'long text',
  checkbox = 'checkbox',
  type = '@type',
  dice = 'dice',
  any = '@select',
  select = 'select'
}

export const fieldTypeOptions: (keyof typeof FieldTypes)[] = ['number', 'text', 'long text', 'checkbox', 'type', 'dice', 'select', 'any']
export const fieldTypesWithValues = [FieldTypes.dice, FieldTypes.type, FieldTypes.select, FieldTypes.any];
